using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Reflection;

using MadMouse.Demo.Plugins.Contracts;

namespace MadMouse.Demo.Plugins.HostForm
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void loadAssemblyToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                Assembly loadedAssembly = Assembly.LoadFrom(openFileDialog1.FileName);
                Type[] types = loadedAssembly.GetExportedTypes(); // my plugins are public

                foreach (Type t in types)
                {
                    if (typeof(Form).IsAssignableFrom(t) && typeof(IPluginCore).IsAssignableFrom(t))
                    {

                        if (typeof(IMDIFormInterface).IsAssignableFrom(t))
                        {
                            // late bound == of the C# 'is' operator
                            if (t.IsDefined(typeof(MDIFormAttribute), false))
                            {
                                try
                                {
                                    Form form = (Form)Activator.CreateInstance(t);
                                    form.MdiParent = this;
                                    form.Show();
                                    IMDIFormInterface pluginForm = (IMDIFormInterface)form;
                                    pluginForm.DoMessage("This is text passed into the Plugin");
                                }
                                catch (MissingMethodException)
                                {
                                    MessageBox.Show(t + " is an Unsupported Plugin");
                                }
                            }

                        }
                        else
                        {
                            if (typeof(IPluginMenuItem).IsAssignableFrom(t))
                            { 
                                
                            }
                            
                        }
                    }
                }

            }
        }
    }
}